// Copyright (C) 1996 Fu-Ren Lin
// Factory.h is a physical agent performing manufacturing

#import "global.h"
#import "InventoryManagement.h"
#import "SCNEntitySwarm.h"
#import "ProductionPlanning.h"
#import "OFPModelSwarm.h"
#import "Trace.h"

@interface Factory: SwarmObject {
 int state;
 Plan * pWkOrder;
 float mfgProcEnd;
 float accumuBusyTime;
 id <List> dispatch;       // store the workorder ready for production
 id <List> dispatchedComps; //store components draw from Instock
 id  invAgent;
 id  prdPlanningAgent;
 id  scnEntity;
 id  ofpModel;

 id  traceAgent;
}

+create: (id) aZone;
-process;
-setInitState;
-(Plan *) removeTopOfDispatch;
-removeDispatchedComps: (Plan *) workOrder;
-addDispatchedComps: (Plan *) workOrder;
-addNewComps: (Plan *) workOrder;
-(Part *) allocateDispatchedComps: (int) identification;
-addDispatchList: (Plan *) workOrder;
-(float) getCapUtilization;
-(float) getAccumuBusyTime;

// setup relationship
-setInvAgent: (id) agent;
-setPrdPlanningAgent: (id) agent;
-setScnEntity: (id) agent;
-setOfpModel: (id) agent;
-setTraceAgent: (id) agent;
@end

