// Copyright (C) 1996 Fu-Ren Lin
// Forecasting.h 

#import "global.h"
#import "OrderManagement.h"
#import "InventoryManagement.h"
#import "ProductionPlanning.h"
#import "SCNEntitySwarm.h"
#import "Trace.h"

@interface Forecasting: SwarmObject {
 id <List> foreDemandL;
 int counterForForecasting;
 id scnEntity;
 id ordAgent;
 id invAgent;
 id ofpModel;
 id prdPlanningAgent;
 id traceAgent;
}

+create: (id)aZone;
-initCounterForForecasting;
-process;
-processBTFMTO: (int) downProp;
-exponentialF: (id) prodGroup act: (id) actualL pred: (id) estimatedL;
-(int) checkTimeToForecasting;
-mergeLists: (id) outList with: (id) inList;
-screenProdSet: (id) inList to: (id) outList with: (id) prodList;
-(int) getQatList: (id) aList prod: (int) no;
-(int) foreSeeDemand: (DemandQuery *) aQuery;
-computeActualDemand: (int) downProp from: (float) stime to: (float) etime prodSet: (id) prodList;
-(int) isInProdList: (int) prodNo within: (id) prodList;
-cleanForeDemandL;

-setScnEntity: (id) agent;
-setOrdAgent: (id) agent;
-setInvAgent: (id) agent;
-setPrdPlanningAgent: (id) agent;
-setTraceAgent: (id) agent;
@end



