// Copyright (C) 1996 Fu-Ren Lin
// InventoryManagement.h  is a physical agent handling parts inventory.

#import "global.h"
#import "OrderManagement.h"
#import "OFPModelSwarm.h"
#import "Trace.h"

@interface InventoryManagement: SwarmObject {
 id <List> inPartBuf;
 id <List> demandList;
 id <List> compDemandList;
 id <List> fulfilledOrders;
 id <List> compFulfilledOrders;
 id <List> inStock;
 id <List> outParts;
 id <List> sentParts;
 id <List> receivers;
 
// lists for statistics purpose
 id <List> ordCycleTs;
 id <List> accuInInvCost;
 id <List> accuOutInvCost;
 id <List> tardyDL;
 id <List> earlyDL;
 id <List> tardyWL;
 id <List> earlyWL;

 id  ordAgent;
 id  scnEntity;
 id  ofpModel;
 id  reOrdAgent;

 id traceAgent;
}

+create: (id) aZone;
-getPart: (Part *) inPart;
-(Part *) getTopOfPartList: (id) aList;
-getOutPartList;
-(IdNo *) getTopOfReceivers;
-moveFromOutPartsToSentParts;
-process;
-(int) checkInv: (int) aPartId;
-(int) checkAvailComps: (Plan *) workOrder;
-addInStock: (Plan *) workOrder;
-addNewStock: (Plan *) workOrder;
-initInStock;
-removeToDispatch: (Plan *) workOrder;
-reduceCompDemandList: (int) partNo size: (int) partQ;
-addToDemandList: (Order *)demandOrder;
-addToCompDemandList: (Order *)anOrder;
-(int) sumOfDemandList: (Order *) order;
-(int) sumOfCompDemandList: (Order *) order;
-(Part *) allocateStock: (int) identification;
-finalInv;

//for forecasting
-getPreDemand: (id) prodList from: (float) startTime to: (float) endTime source: (id) demandProds;
-(int) isInInvSet: (int) prodNo in: (id) prodList;

-getDemandList;
-getFulfilledOrders;
-getCompDemandList;
-getCompFulfilledOrders;

// for statistics
-computeOrdCycleTime: (Order *) demandOrder;
-(float) getAvgCycleT;
-(float) getFulfilledRate;

-addToInvStat: (Plan *) workOrder;
-accumuInputInvCost: (Part *) inPart;
-accumuOutputInvCost: (Part *) outPart;
-(float) getAvgInvCost;

-computeDueDatePerformance: (Order *) demandOrder;
-(float) getAvgDueDatePerformance: (id) dueDateList;
-getTardyDL;
-getEarlyDL;
-getTardyWL;
-getEarlyWL;

-setOrdAgent: (id) agent;
-setScnEntity: (id) agent;
-setOfpModel: (id) agent;
-setReOrdAgent: (id) agent;
-setTraceAgent: (id) agent;
@end


