// Copyright (C) 1996 Fu-Ren Lin
// MaterialPlanning.h 
//      is a physical agent does material planning for manufacturing

#import "global.h"
#import "SCNEntitySwarm.h"
#import "OrderManagement.h"
#import "InventoryManagement.h"
#import "ProductionPlanning.h"
#import "OFPModelSwarm.h"
#import "Trace.h"

@interface MaterialPlanning: SwarmObject {
 id <List> mrpPlan;
 id <List> processedPlan;  //store the mrped plans which wait for dispatch
 
 id scnEntity;
 id ordAgent;
 id invAgent;
 id prdPlanningAgent;
 id ofpModel;

 id traceAgent;
}

+create: (id) aZone;
-process;
-(float) checkMatAvail: (Order *) mfgOrder level: (int) upProp;
-(int) checkCompProcessedPlanNotDispatched: (int) prodNo comp: (int) compNo;
-removeProcessedPlan: (Plan *) aPlan;
-(float) getLeadTime: (int) prodId;
-(int) checkProcessedPlanNotDispatched: (int) prodNo;
-(float) determineCommitDateFromMultiSuppliers: (Order *) outOrder level: (int) upProp;
-(int) hasCommonComp: (int) aCompNo in: (id) bList;

//----set agents
-setOrdAgent: (id) agent;
-setInvAgent: (id) agent;
-setPrdPlanningAgent: (id) agent;
-(Plan *) getTopOfMrpPlan;
-moveFromMrpPlanToProcessedPlan;
-setScnEntity: (id) agent;
-setOfpModel: (id) agent;
-setTraceAgent: (id) agent;
@end




