// Copyright (C) 1996 Fu-Ren Lin
//OFPBatchSwarm.m

#import "OFPBatchSwarm.h"

@implementation OFPBatchSwarm
+create: (id) aZone {
  OFPBatchSwarm * obj;
  obj = [super create: aZone];
  return obj;
}

//------------
-buildObjects {
  trace = [Trace create: [self getZone]];

  [super buildObjects];
  
// create the model swarm here.
  ofpModelSwarm = [OFPModelSwarm create: [self getZone]];
  [ofpModelSwarm buildObjects];
  
// create the statistic swarm here.  
  ofpStatSwarm = [OFPStatSwarm create: [self getZone]];
  [ofpStatSwarm buildObjects];
  [ofpStatSwarm setOfpModel: ofpModelSwarm];

   return self;
}  

//---------
-buildActions {
  [super buildActions];
  
// model swarm builds its own schedule.
  [ofpModelSwarm buildActions];
  
// statistics swarm builds itw own schedule.
  [ofpStatSwarm buildActions];


// stop schedule
  stopSchedule = [Schedule create: [self getZone]];
  [stopSchedule at: endDay*UNIT createActionTo: self message: M(stopRunning)];
  
  return self;
} 
 
//------------
-activateIn: (id) swarmContext {
  [super activateIn: swarmContext];

// activate the model swarm.
  [ofpModelSwarm activateIn: self];

// activate the statistics swarm.
  [ofpStatSwarm activateIn: self];

// activate the stop schedule
  [stopSchedule activateIn: self];

// Activate returns the swarm activity
  return [self getSwarmActivity];
}

//----------
-go {
 // printf("No DISPLAY environment variable was set, so we're running without graphics.\n");
  
  [swarmActivity run];
  return [swarmActivity getStatus];
}


//-------------
-stopRunning {
  [getTopLevelActivity() terminate];
  fclose(freport);
  [trace closeDebugFile];
  return self;
}


@end




