// Copyright (C) 1996 Fu-Ren Lin
// OrderManagement.h
// OrderManagemenet is a logical agent handling orders.

#import "global.h"
#import "InventoryManagement.h"
#import "ProductionPlanning.h"
#import "Trace.h"

@interface OrderManagement: SwarmObject {
 id <List> outOrders;
 id <List> sentOrders;
 id <List> inOrdBuf;
 id <List> backOrders;
 float accumuOrder, currentInv, inOrdering;

 id ofpModel;
 id invAgent;
 id scnEntity;
 id prdPlanningAgent;
 id mrpAgent;

 id traceAgent;
}

+create: (id) aZone;
-getOrder: (Order *) inOrder;
-(Order *) getTopOfOrderList: (id) aList;
-getOutOrderList;
-moveFromOutOrdersToSentOrders;
-(float) estimateCommitDate: (Order *) anOrder level: (int) upProp;
-(float) estimateProdArrivalTime: (Order *) anOrder level: (int)upProp;
-(int) checkAvailInv: (Order *) currentOrder;
-(int) checkInOrdering: (Order *) anOrder;
-(int) checkInOrderingForMrp: (IdNo *) aComp;
-(int) checkOrderList: (id) ordList with: (int) prodId;
-(float) getLatestOrderDueDate: (id) ordList for: (int) prodId with: (int) inOrdering;

-addOneToOutOrders: (Order *) anOrder;
-reduceSentOrders: (Part *) aPart;

-moveBackOrdersToOutOrders;
-moveBackOrdersTomfgOrders;
-removeBackOrders;
-(int) accumuBackOrders: (int) prodNo;

-setInvAgent: (id) agent;
-setOfpModel: (id) agent;
-setScnEntity: (id) agent;
-setPrdPlanningAgent: (id) agent;
-setMrpAgent: (id) agent;
-setTraceAgent: (id) agent;

@end




