// Copyright (C) 1996 Fu-Ren Lin
// ProductionPlanning.h is a logical agent performing production planning

#import "global.h"
#import "Factory.h"
#import "MaterialPlanning.h"
#import "Trace.h"

@interface ProductionPlanning: SwarmObject {
 id <List> buildPlan;  // for buildplan
 id <List> dispatchedPlan; // store the buildplan done the dispatch
 id <List> finishedPlan;  // store plan has been produced
 id <List> mfgOrders;
 int counterForSchedule;
 id scnEntity;
 id mrpAgent;
 id capPlanningAgent;

 id traceAgent;
}

+create: (id)aZone;
-process;

// methods for synchronzing material and capacity planning while planning..
-processSynchronized;
-moveCapPlanToPrdPlan: (id) capPlanList;

//  methods for basic planning process...
-processNone;
-initCounterForSchedule;
-(int) checkTimeToSchedule;
-addMfgOrderToPlan: (Order *) order start: (float) startTime end: (float) finTime;
-(Order *) removeTopMfgOrders;
-(Order *) reduceTopMfgOrders: (float) ratio;
-(Plan *) getTopWorkOrders;
-removeTopWorkOrders;
-(float) checkUsedCap: (int) prodNo size: (int) prodQ;
-addToMfgOrders: (Order *) inOrder;
-addToFinishedPlan: (Plan *) disPlan;
-(float) estimateDueDate: (Order *) anOrder;
-fulfillBuildPlan: (Plan *)workOrder;
-(Plan *) checkBuildPlanForMrp;
-markBuildPlanForMrp: (char) mark;
-(float) getStartTbyCheckingMfgOrders;
-setScnEntity: (id) agent;
-setMrpAgent: (id) agent;
-setCapPlanningAgent: (id) agent;
-setTraceAgent: (id) agent;

// for commitdate estimation
-(int) getNumProdInPlanning: (Order *) anOrder;
-(int) getNumMfgOrders: (Order *) anOrder;
-(float) getLatestMfgOrdersDueDate: (int) prodId with: (int) receiving;
-(float) getLastMfgOrderDueDate;
-(float) getLatestBuildPlanFinishedTime: (int) prodId with: (int) receiving;

-(float) estimateFinishTime: (Order *) anOrder level: (int) upProp;
-(float) estimateFinishTime_withoutSMC: (Order *) anOrder level: (int) upProp;
-(float) estimateFinishTime_withSMC: (Order *) anOrder level: (int) upProp;
@end


