// Copyright (C) 1996 Fu-Ren Lin
// Public.h 

#import <swarmobject.h>

// order object
@interface Order: SwarmObject {	
@public
  int  itemId;
  int  itemQ;
  float ordArrTime;
  float wantDate;
  float dueDate;
  int senderId;
}
-copy: (id) aZone;
@end

// part object
@interface Part: SwarmObject {
@public
  int  partId;
  int  partQ;
  float partArrTime;
}
-copy: (id) aZone;
@end

// plan object
@interface Plan: SwarmObject {
@public
   int prodId;
   int prodQ;
   float scheduledStart;
   float finishedTime;
   int  mrpMark;
}
-copy: (id) aZone;
@end

// component object
@interface Components: SwarmObject {
@public
 int prodId;
 int compQ;
 id <List> compList;
}
@end

// time object
@interface Ttime: SwarmObject {
@public
 float ttime;
}
@end

// prodId object
@interface IdNo: SwarmObject {
@public
 int no;
}
@end

@interface INV: SwarmObject {
@public
 int prodId;
 int prodQ;
 double cost;
}
@end

@interface OrdCost: SwarmObject {
@public
 int supplierId;
 float cost;
}
@end

@interface InvCost: SwarmObject {
@public
 int prodId;
 float unitCost;
}
@end

@interface Query: SwarmObject {
@public
 int queryId;
 int prodId;
 int prodQ;
 float prodNeedT;
 float queryArrTime;
 int senderId;
}
@end

@interface Bid: SwarmObject {
@public
 int queryId;
 int prodId;
 int prodQ;
 float marginalC;
 float prodDeliverT;
 float bidArrTime;
 int senderId;
}
-copy: (id) aZone;
@end

@interface QueryRec: SwarmObject {
@public
 int queryId;
 float querySentT;
 int sentQ;
 int returnQ;
 id <List> returnBids;
 id <List> winnerList;
}
@end

@interface Evaluation: SwarmObject {
@public
 int   prodQ;
 float mCost;
 float timeGap;
 float utility;
 int supplierId;
}
@end

@interface Capacity: SwarmObject {
@public
 float startTime;
 float endTime;
 float usedCap;
 int   fullMark;
}
@end

@interface DemandQuery: SwarmObject {
@public
 int prodId;
 float startTime;
 float endTime;
 int queryLayer;
}
-copy: (id) aZone;
@end
