// Copyright (C) 1996 Fu-Ren Lin
// ReOrdering.h 

#import "global.h"
#import "OrderManagement.h"
#import "InventoryManagement.h"
#import "ProductionPlanning.h"
#import "MaterialPlanning.h"
#import "SCNEntitySwarm.h"
#import "OFPModelSwarm.h"
#import "Trace.h"

@interface ReOrdering: SwarmObject {
 id <List> eoqList;
 id <List> ropList;
 id <List> ropLeadTimeList;
 id <List> compDQs;
 int counterForReOrdering;

 id scnEntity;
 id ordAgent;
 id invAgent;
 id prdPlanningAgent;
 id mrpAgent;
 id ofpModel;
 id forecastingAgent;

 id traceAgent;
}

+create: (id) aZone;
-process;
-initCounterForReOrdering;
-(int) checkTimeToReOrdering: (Part *) anEOQ;
-reOrderingProcess: (Part *) anEOQ;
-calcurateEOQ: (id) invDQs endItem: (int) isEndItem;
-calcurateROP: (id) invDQs endItem: (int) isEndItem;
-calcurateCompEOQ: (id) invDQs;
-calcurateCompROP;
-(float) getROPLeadTime: (Order *) anOrder endItem: (int) isEndItem;
-getEoqList;
-getCompDQs;
-reviseROP: (int) prodNo ;
-reviseROPLeadTime: (int) prodNo avail: (float) newLeadTime;
-(int) reviseDeltaQ: (int) prodNo;
-(int) queryDemand: (DemandQuery *) aQuery;
-(int) estimateNextReOrdering: (DemandQuery *) aQuery;
-(int) getEOQ: (int) prodNo;

-setScnEntity: (id) agent;
-setOrdAgent: (id) agent;
-setInvAgent: (id) agent;
-setMrpAgent: (id) agent;
-setPrdPlanningAgent: (id) agent;
-setOfpModel: (id) agent;
-setForecastingAgent: (id) agent;
-setTraceAgent: (id) agent;

@end


