// Copyright (C) 1996 Fu-Ren Lin
// ScnManagemnt.h
// ScnManagement is used for management supplier selection and resource
//  allocation to faciliate production planning and ofp.

#import "global.h"
#import "OrderManagement.h"
#import "InventoryManagement.h"
#import "Factory.h"
#import "Dispatching.h"
#import "MaterialPlanning.h"
#import "ProductionPlanning.h"
#import "OFPModelSwarm.h"
#import "SCNEntitySwarm.h"
#import "Forecasting.h"
#import "ReOrdering.h"
#import "Trace.h"

@interface ScnManagement: SwarmObject {
 id <List> bidList;    // storage for bid sent from the scnM
 id <List> bidInBuf;   // storage for returning bids from other entities
 id <List> queryList;  // starage for queries sent from the scnM
 id <List> queryRecList;  // starage for queries sent from the scnM
 id <List> queryInBuf; // storage for incoming queries from other entities
 id <List> awardInBuf; // storage for incoming award from other entities
 id <List> outSourcingList; // demand list from other agents within the entity
 id <List> waitList;   // processed demandlist storage
 
 int qCnt;
 float considerationTime;

 id ofpModel;
 id scnEntity;
 id ordAgent;
 id invAgent;
 id prdPlanningAgent;
 id mrpAgent;

 id traceAgent;
}

+create: (id) aZone;
-process;
-generateQuery;
-processComingQuery;
-processReturningBid;
-processReturningAward;
-initBiddingCounter;
-removeOneQueryRec: (QueryRec *) theQueryRec;
-acceptDemandOrder: (Order *) anOrder;
-(Order *) moveFromOutSourcingListToWaitList;
-sendQueries: (Query *) aQuery;
-receiveBid: (Bid *) aBid;
-(QueryRec *) allocateQueryRec: (Bid *) returnBid;
-(int) checkDoubleBid: (QueryRec *) aQueryRec from: (Bid *)returnBid;
-evaluateAndRespondToBids: (Bid *) returnBid;
-reactToQuery: (Query *) aQuery;
-receiveQuery: (Query *) inQuery;
-receiveAward: (Query *) inAward;
-returnNullBid: (Query *) aQuery;
-(Order *) convertQueryToOrder: (Query *) aQuery;
-(Query *) convertBidToQuery: (Bid *) aBid;
-(float) calcurateMarginalCost: (Query *) aQuery with: (int) needQ;
-reSendQueries: (Query *) aQuery with: (int) prodQ;
-(int) sendAward: (Query *) aQuery to: (Evaluation *) aEval max: (int)maxQ;
-sendLoser: (Query *) aLoser to: (int) aBidderNo;
-sendLosersToAllBidders: (id) returnBidList;
-convertAwardToDemandOrder: (Query *) anAward;
-(int) isAWinner: (int) sender by: (id) winnerList;
-removeBids: (Query *) aLoser;

-setScnEntity: (id) agent;
-setOrdAgent: (id) agent;
-setInvAgent: (id) agent;
-setMrpAgent: (id) agent;
-setPrdPlanningAgent: (id) agent;
-setOfpModel: (id) agent;
-setTraceAgent: (id) agent;
@end




