// Copyright (C) 1996 Fu-Ren Lin
//Trace.m

#import "Trace.h"

@implementation Trace
//----open debug file for debugging purpose
-openDebugFile {
  if ((fdebug = fopen(debugFile, "w")) == NULL) { 
    [SourceMessage raiseEvent: "Error in opening file debugFile"];
  }
  return self;
}

-closeDebugFile {
 fclose(fdebug);
 return self;
}

//--
-pInt: (int) code value: (int) intV  fmt: (int) space {
 if (code == 0)
  return self;
 else if (code == 1) {
  if (space == Tab)
   printf( "%d\t", intV);
  else if (space == NL)
   printf( "%d\n", intV);
  else if (space == Space)
   printf( "%d ", intV);
 }
 else if (code == 2) {
  if (space == Tab)
   fprintf(fdebug, "%d\t", intV);
  else if (space == NL)
   fprintf(fdebug, "%d\n", intV);
  else if (space == Space)
   fprintf(fdebug, "%d ", intV);
 }
 return self;
}
//--
-pFloat: (int) code value: (float) floatV  fmt: (int) space {
 if (code == 0)
   return self;
 else if (code == 1) {
   if (space == Tab)
     printf( "%f\t", floatV);
   else if (space == NL)
     printf( "%f\n", floatV);
   else if (space == Space)
     printf( "%f ", floatV);
 }
 else if (code == 2) {
   if (space == Tab)
    fprintf(fdebug, "%f\t", floatV);
   else if (space == NL)
    fprintf(fdebug, "%f\n", floatV);
   else if (space == Space)
    fprintf(fdebug, "%f ", floatV);
 }
 return self;
}

//--
-pOrder: (int)code value: (Order *) anOrder {
 if (code == 0)
   return self;
 else  if (code == 1)
   printf("%d, %d, %f, %f, %f, %d\n", anOrder->itemId,anOrder->itemQ, anOrder->ordArrTime, anOrder->wantDate, anOrder->dueDate, anOrder->senderId);
 else  if (code == 2)
   fprintf(fdebug, "%d, %d, %f, %f, %f, %d\n", anOrder->itemId,anOrder->itemQ, anOrder->ordArrTime, anOrder->wantDate, anOrder->dueDate, anOrder->senderId);

 return self;
}
//--
-pPart: (int) code value: (Part *) aPart {
 if (code == 0)
   return self;
 else if (code == 1)
   fprintf(fdebug, "%d, %d, %f\n", aPart->partId, aPart->partQ,aPart->partArrTime);
 else if (code == 2)
   fprintf(fdebug, "%d, %d, %f\n", aPart->partId, aPart->partQ,aPart->partArrTime);
 return self;
}

//--
-pPlan: (int) code value: (Plan *) aPlan {
 if (code == 0)
   return self;
 else  if (code == 1)
   printf("%d, %d, %f, %f, %d\n", aPlan->prodId, aPlan->prodQ,aPlan->scheduledStart, aPlan->finishedTime, aPlan->mrpMark);
 else if (code == 2)
   fprintf(fdebug, "%d, %d, %f, %f, %d\n", aPlan->prodId, aPlan->prodQ,aPlan->scheduledStart, aPlan->finishedTime, aPlan->mrpMark);
 
 return self;
} 

//--
-pHeader: (int) code value: (char *) header fmt: (int) space {
  if (code == 0)
   return self;
  else if (code == 1) {
    if (space == Tab)
      printf( "%s\t", header);
    else if (space == NL)
       printf( "%s\n", header);
    else if (space == Space)
       printf( "%s ", header);
  }
  else if (code == 2) {
   if (space == Tab)
     fprintf(fdebug, "%s\t", header);
   else if (space == NL)
     fprintf(fdebug, "%s\n", header);
   else if (space == Space)
     fprintf(fdebug, "%s ", header);
   }
   return self;
}

//--
-pQuery: (int) code value: (Query *) aQuery {
 if (code == 0)
   return self;
 else if (code == 1)
   printf("%d, %d, %d, %f, %f, %d\n", aQuery->queryId, aQuery->prodId,
aQuery->prodQ, aQuery->prodNeedT, aQuery->queryArrTime, aQuery->senderId);
  else if (code == 2)
   fprintf(fdebug, "%d, %d, %d, %f, %f, %d\n", aQuery->queryId, aQuery->prodId,
aQuery->prodQ, aQuery->prodNeedT, aQuery->queryArrTime, aQuery->senderId);
 
return self;
} 

//--
-pBid: (int) code value: (Bid *) aBid {
 if (code == 0)
   return self;
 else if (code == 1)
   printf("%d, %d, %d, %f, %f, %f, %d\n", aBid->queryId, aBid->prodId,aBid->prodQ, aBid->marginalC, aBid->prodDeliverT, aBid->bidArrTime, aBid->senderId);
 else if (code == 2)
   fprintf(fdebug, "%d, %d, %d, %f, %f, %f, %d\n", aBid->queryId, aBid->prodId,
aBid->prodQ, aBid->marginalC, aBid->prodDeliverT, aBid->bidArrTime, aBid->senderId);
 return self;
} 

//--
-pAward: (int) code value: (Query *) anAward {
 if (code == 0)
   return self;
 else if (code == 1)
   printf("%d, %d, %d, %f, %f, %d\n", anAward->queryId, anAward->prodId,anAward->prodQ, anAward->prodNeedT, anAward->queryArrTime, anAward->senderId);
 else if (code == 2)
   fprintf(fdebug, "%d, %d, %d, %f, %f, %d\n", anAward->queryId,anAward->prodId, anAward->prodQ, anAward->prodNeedT, anAward->queryArrTime, anAward->senderId);

 return self;
} 

//--
-pEval: (int) code value: (Evaluation *) anEval {
 if (code == 0)
   return self;
 else if (code == 1)
   printf("%d, %f, %f, %f, %d\n", anEval->prodQ, anEval->mCost, anEval->timeGap, anEval->utility,  anEval->supplierId);
 else if (code == 2)
   fprintf(fdebug, "%d, %f, %f, %f, %d\n", anEval->prodQ, anEval->mCost, anEval->timeGap, anEval->utility,  anEval->supplierId);
 return self;
} 

//--
-pINVCost: (int) code value: (INV *) aCost {
 if (code == 0)
   return self;
 else if (code == 1)
   printf("%d, %d, %f\n", aCost->prodId, aCost->prodQ, aCost->cost);
 else if (code == 2)
   fprintf(fdebug, "%d, %d, %f\n", aCost->prodId, aCost->prodQ, aCost->cost);
 return self;
}

@end

